#include <unistd.h>
#include <fcntl.h>
#include <pthread.h> 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

pthread_t thr_1; 
pthread_t thr_2; 
pthread_t thr_3; 

const int amt = 25;

void *mod0() {

  char cmd[125];

  for (int i = 0; i < amt * 4; i++) {
       sprintf(cmd, "convert -swirl %d ./bw.png /tmp/swirl%03d.png", i*6, i); 
       system(cmd);
       sprintf(cmd, "convert -composite ./sky.png /tmp/swirl%03d.png /tmp/swirl%03d.png", i, i); 
       system(cmd);
  }

  system("convert -delay 15 -dispose previous /tmp/swirl* bw-swirl.gif");

  pthread_exit(NULL);

}

void *mod1() {

  char cmd[125];

  for (int i = 0; i < amt * 2; i++) {
       sprintf(cmd, "convert -implode %f ./bw.png /tmp/implode%03d.png", (i+0.3)*0.07, i); 
       system(cmd);
       sprintf(cmd, "convert -composite ./sky.png /tmp/implode%03d.png /tmp/implode%03d.png", i, i); 
       system(cmd);
  }

  system("convert -delay 15 -dispose previous /tmp/implode* bw-implode.gif");

  pthread_exit(NULL);

}

void *mod2() {
  char cmd[125];

  for (int i = 0; i < amt * 3; i++) {
       sprintf(cmd, "convert -background 'rgba(0,0,0,0)' -rotate %d ./bw-norope.png /tmp/rotate%03d.png", i*5, i); 
       system(cmd);
       sprintf(cmd, "convert -composite ./sky.png /tmp/rotate%03d.png /tmp/rotate%03d.png", i, i); 
       system(cmd);
  }

  system("convert -delay 15 -dispose previous /tmp/rotate* bw-rotate.gif");

  pthread_exit(NULL);
}


int main(void) { 

     int thread_return;
     system("rm /tmp/*png");

     thread_return = pthread_create(&thr_1, NULL, mod0, NULL);
     if (thread_return != 0) 
          return(thread_return);

     thread_return = pthread_create(&thr_2, NULL, mod1, NULL);
     if (thread_return != 0) 
          return(thread_return); 

     thread_return = pthread_create(&thr_3, NULL, mod2, NULL);
     if (thread_return != 0) 
          return(thread_return); 

	pthread_join(thr_1, NULL); 
	pthread_join(thr_2, NULL); 
	pthread_join(thr_3, NULL); 

	return 0; 
} 

